﻿Imports System.IO

Public Class Form1

    ' strFTPPath는 서버측 파일 경로, strLocalPath는 클라이언트측 파일 경로
    Private strFTPPath As String()
    Private strLocalPath As String()
    Private i As Integer = 0

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SmartForm1.MainForm = Me

        ' FTP Server측 File경로
        strFTPPath = New String(3) {}
        ' // Client측 File경로
        strLocalPath = New String(3) {}

        ' 다운로드 할 파일들의 전체경로를 배열에 저장
        strFTPPath(0) = "UpdateFiles//RemoteUpdate.exe"             ' 서버에서 업데이트 할 파일의 경로
        strLocalPath(0) = "SD Card\\UpdateFiles\\RemoteUpdate.exe"  ' 로컬에서 파일을 다운로드 받을 경로

        strFTPPath(1) = "UpdateFiles//SmartXNCommon.dll"
        strLocalPath(1) = "SD Card\\UpdateFiles\\SmartXNCommon.dll"

        strFTPPath(2) = "UpdateFiles//SmartXNFDCommon.dll"
        strLocalPath(2) = "SD Card\\UpdateFiles\\SmartXNFDCommon.dll"

        ' 리스트 항목 모두 삭제
        lsbFileList.Items.Clear()

        ' 다운로드 파일 리스트 표시
        For k As Integer = 0 To 3 - 1
            lsbFileList.AddItem(strFTPPath(k))
        Next

        ' 파일의 개수 만큼 다운로드 확인하는 타이머
        SmartTimer1.Interval = 1000
        ' 각 파일의 다운로드 상태가 100%일 때까지 확인하는 타이머
        SmartTimer2.Interval = 100
        ' 전체 파일의 다운로드 완료 시 업데이트 처리를 하는 타이머
        SmartTimer3.Interval = 1000

        ' FTP 서버로부터 다운로드 받은 파일의 업데이트 경로를 설정
        SmartUpdate1.FromFilePath = "SD Card\\UpdateFiles"
        SmartUpdate1.ToFilePath = "Flash Disk\\Run"
        SmartUpdate1.Restart = SmartX.SmartUpdate.RESTARTFLAG.AUTORUNEXECUTE
    End Sub

    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        ' 연결 해제 버튼
        SmartFTP1.DisConnect()
    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        ' 아래 내용은 FTP 서버의 연결 설정 정보를 설정 합니다.
        ' 테스트하고자 하시는 FTP 서버 정보로 수정 하세요.
        SmartFTP1.ServerFTPAddress = "192.168.1.41"
        SmartFTP1.PortNo = 21
        SmartFTP1.PassiveMode = True
        SmartFTP1.UserID = "hns"
        SmartFTP1.Password = ""

        ' FTP 연결 요청
        If SmartFTP1.Connect() = True Then
            labStatus.Text = "연결 성공"
        Else
            labStatus.Text = "연결 실패"
        End If
    End Sub

    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisconnect.Click
        SmartFTP1.DisConnect()
    End Sub

    ' 파일 다운로드 버튼의 클릭 이벤트
    Private Sub btnDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDown.Click
        ' 업데이트 파일을 다운로드 할 디렉터리가 존재하지 않으면 생성
        Dim di As DirectoryInfo = New DirectoryInfo("SD Card\\UpdateFiles")
        If di.Exists = False Then
            di.Create()
        End If

        ' 리스트 항목 모두 삭제
        lsbFileList.Items.Clear()

        SmartTimer1.Start()
    End Sub

    ' 파일 업데이트 버튼의 클릭 이벤트
    Private Sub btnUpdateStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdateStart.Click
        SmartTimer3.Start()
    End Sub

    ' 종료 버튼의 클릭 이벤트
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        ' 연결 해제 버튼
        SmartFTP1.DisConnect()

        ' 프로그램 종료
        Application.Exit()
    End Sub

    Private Sub SmartTimer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SmartTimer1.Tick
        SmartTimer1.Stop()

        ' 파일의 개수만큼 동작
        If i < 3 Then
            ' 파일 다운로드 시작
            SmartFTP1.FileDownload(strFTPPath(i), strLocalPath(i))
            ' 다운로드 상태 100% 체크 확인 타이머 시작
            SmartTimer2.Start()
        Else
            ' 전체 파일의 다운로드 완료
            labStatus.Text = "Finish"
            ' 파일 다운로드 종료
            SmartTimer1.Stop()
            ' 전체 파일의 다운로드 완료 시 SmartUpdate로 파일 업데이트 시작
            SmartTimer3.Start()
        End If
    End Sub

    Private Sub SmartTimer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SmartTimer2.Tick
        ' Percentage가 100%이면 해당 파일의 다운로드가 완료된 상태
        If SmartFTP1.Percentage = 100 Then
            ' ListBox에 [완료] 메시지를 출력
            lsbFileList.AddItem("[완료]" & strFTPPath(i))
            ' 다음 파일 다운로드를 위해 i값 1증가
            i += 1
            ' 다음 파일 다운로드를 위해 smartTimer2 정지
            SmartTimer2.Stop()
            ' 다음 파일 다운로드를 위해 smartTimer1 시작
            SmartTimer1.Start()
        ElseIf SmartFTP1.Percentage = -1 Then
            ' -1이면 다운로드 실패
            ' ListBox에 [실패] 메시지를 출력
            lsbFileList.AddItem("[실패]" & strFTPPath(i))
            i += 1
            SmartTimer2.Stop()
            SmartTimer1.Start()
        Else
            ' 현재 파일의 다운로드 %를 표시
            labStatus.Text = SmartFTP1.Percentage.ToString() & "%"
        End If
    End Sub

    ' SmartUpdate를 위한 SmartTimer Tick Event
    Private Sub SmartTimer3_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SmartTimer3.Tick
        SmartTimer3.Stop()

        ' 업데이트 시작의 지연 시간을 설정
        SmartUpdate1.UpdateStartInterval = 3000

        If SmartUpdate1.UpdateCheck() = True Then
            Dim dResult As DialogResult = SmartX.SmartMessageBox.Show("업데이트를 시작 하시겠습니까?", "업데이트 시작", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

            If dResult = DialogResult.Yes Then
                SmartUpdate1.Start()
                SmartForm1.Close()
            End If
        Else
            SmartX.SmartMessageBox.Show("현재 파일이 최신 버전입니다.")
        End If
    End Sub
End Class
